<?xml version="1.0" encoding="UTF-8"?>
<odoo>
    <template id="report_delivery_document_ferrosa">
        <t t-call="web.html_container">
            <t t-call="web.external_layout">
                <t t-set="o" t-value="o.with_context(lang=o.partner_id.lang)" />
                <t t-set="partner" t-value="o.partner_id or (o.move_lines and o.move_lines[0].partner_id) or False"/>
                <t t-if="partner" name="partner_header">
                    <t t-set="address">
                        <div t-esc="partner"
                        t-options='{"widget": "contact", "fields": ["address", "name", "phone"], "no_marker": True}'/>
                    </t>
                </t>
                <div class="page">
                    <h2>
                        <span t-field="o.name"/>
                    </h2>
                    <div class="row mt32 mb32" name="div_origin_date">
                        <div t-if="o.origin" class="col-auto" name="div_origin">
                            <strong>Order:</strong>
                            <p t-field="o.origin"/>
                        </div>
                        <div t-if="o.state" class="col-auto" name="div_sched_date">
                            <strong>Shipping Date:</strong>
                            <t t-if="o.state == 'done'">
                                <p t-field="o.date_done"/>
                            </t>
                            <t t-if="o.state != 'done'">
                                <p t-field="o.scheduled_date"/>
                        </t>
                        </div>
                    </div>
                    <table class="table table-sm" t-if="o.state!='done'" name="stock_move_table">
                        <thead>
                            <tr>
                                <th name="th_sm_product"><strong>Product</strong></th>
                                <th name="th_sm_quantity"><strong>Quantity</strong></th>
                            </tr>
                        </thead>
                        <tbody>
                            <t t-set="lines" t-value="o.move_lines.filtered(lambda x: x.product_uom_qty)"/>
                            <tr t-foreach="lines" t-as="move">
                                <td>
                                    <span t-field="move.product_id"/>
                                    <p t-if="move.description_picking != move.product_id.name">
                                        <span t-field="move.description_picking"/>
                                    </p>
                                </td>
                                <td>
                                    <span t-field="move.product_uom_qty"/>
                                    <span t-field="move.product_uom"/>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <table class="table table-sm mt48" t-if="o.move_line_ids and o.state=='done'" name="stock_move_line_table">
                        <t t-set="has_serial_number" t-value="o.move_line_ids.mapped('lot_id')" />
                        <thead>
                            <tr>
                                <th name="th_sml_product"><strong>Product</strong></th>
                                <th name="lot_serial" t-if="has_serial_number" groups="stock.group_lot_on_delivery_slip">
                                    Lot/Serial Number
                                </th>
                                <th name="th_sml_quantity" class="text-center"><strong>Quantity</strong></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr t-foreach="o.move_line_ids" t-as="move_line">
                                <td>
                                    <span t-field="move_line.product_id"/>
                                    <p t-if="move_line.move_id.description_picking != move_line.product_id.name">
                                        <span t-field="move_line.move_id.description_picking"/>
                                    </p>
                                </td>
                                <td t-if="has_serial_number and move_line.lot_id.name" groups="stock.group_lot_on_delivery_slip">
                                    <span t-field="move_line.lot_id.name"/>
                                </td>
                                <td t-elif="has_serial_number" groups="stock.group_lot_on_delivery_slip">
                                    <span t-field="move_line.lot_name"/>
                                </td>
                                <td class="text-center">
                                    <span t-field="move_line.qty_done"/>
                                    <span t-field="move_line.product_uom_id"/>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div class="row justify-content-end">
                        <div class="col-auto" style="font-size: 10px;">
                            Valor en mercancias y/o servicios que eh recibido a mi entera satisfaccion.
                            <br></br>
                            Nombre y firma
                            <br></br>
                            ______________
                        </div>
                    </div>
                    <p>
                        <t t-if="o.backorder_ids and o.backorder_ids.filtered(lambda x: x.state not in ('done', 'cancel'))">
                            All items couldn't be shipped, the remaining ones will be shipped as soon as they become available.
                        </t>
                    </p>
                </div>
            </t>
        </t>
    </template>

    <template id="report_deliveryslip_ferrosa">
        <t t-foreach="docs" t-as="o">
            <t t-call="delivery_report.report_delivery_document_ferrosa" t-lang="o.partner_id.lang"/>
        </t>
    </template>

    
    <record id="paperformat_delivery_ferrosa" model="report.paperformat">
        <field name="name">Vale Entrega Ferrosa</field>
        <field name="default" eval="True" />
        <field name="format">custom</field>
        <field name="page_height">180</field>
        <field name="page_width">68</field>
        <field name="orientation">Portrait</field>
        <field name="margin_top">20</field>
        <field name="margin_bottom">20</field>
        <field name="margin_left">0</field>
        <field name="margin_right">0</field>
        <field name="header_line" eval="False" />
        <field name="header_spacing">20</field>
        <field name="dpi">90</field>
    </record>

    <report
        string="Delivery Slip"
        id="action_report_delivery"
        model="stock.picking"
        report_type="qweb-pdf"
        name="delivery_report.report_deliveryslip_ferrosa"
        file="delivery_report.report_deliveryslip_ferrosa"
        paperformat="paperformat_delivery_ferrosa"
        print_report_name="'Delivery Slip - %s - %s' % (object.partner_id.name or '', object.name)"
    />

    <template id="delivery_ferrosa_report" inherit_id="delivery_report.report_delivery_document_ferrosa">
        <xpath expr="//div[@t-esc='partner']" position="attributes">
            <attribute name="style">font-size: 8px; margin-right:9px;</attribute>
        </xpath>
        <xpath expr="//div[@name='div_origin']" position="attributes">
            <attribute name="style">font-size: 10px; </attribute>
        </xpath>
        <xpath expr="//div[@name='div_sched_date']" position="attributes">
            <attribute name="style">font-size: 10px; </attribute>
        </xpath>
        <xpath expr="//span[@t-field='o.name']" position="attributes">
            <attribute name="style">font-size: 15px; </attribute>
        </xpath>
        <xpath expr="//div[@name='div_origin_date']" position="after">
            <div class="row justify-content-end" t-if="o.sudo().sale_id.client_order_ref">
                <div class="col-auto" style="font-size: 10px;">
                    <strong>Customer Reference:</strong>
                    <p t-field="o.sudo().sale_id.client_order_ref"/>
                </div>
            </div>
        </xpath>
        <xpath expr="//table[@name='stock_move_table']" position="attributes">
            <attribute name="style">font-size: 12px; </attribute>
        </xpath>
        <xpath expr="//table[@name='stock_move_line_table']" position="attributes">
            <attribute name="style">font-size: 12px; </attribute>
        </xpath>
    </template>

    <template id="delivery_ferrosa_report_header" inherit_id="web.external_layout_background">
        <xpath expr="//div[hasclass('o_background_header')]" position="attributes">
            <attribute name="style">font-size: 13px;</attribute>
        </xpath>
        <xpath expr="//div[@t-attf-class='o_company_#{company.id}_layout footer o_background_footer']" position="attributes">
            <attribute name="style">font-size: 10px;</attribute>
        </xpath>
        
        <xpath expr="//div[hasclass('company_address')]" position="attributes">
            <attribute name="style">margin-right:3px; </attribute>
        </xpath>
    </template>

    <template id="report_delivery_document_inherit_sale_stock_ferrosa" inherit_id="sale_stock.report_delivery_document_inherit_sale_stock">
        <xpath expr="//div[hasclass('row')]/div[@t-if='o.sudo().sale_id.client_order_ref']" position="attributes">
            <attribute name="t-att-style">'display: none;'</attribute>
        </xpath>
    </template>
</odoo>

